Index: /trunk/XTIDE_Universal_BIOS/Inc/BootMenu.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/BootMenu.inc	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Inc/BootMenu.inc	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	BootMenu.inc
-; Project name	:	IDE BIOS
-; Created date	:	26.3.2010
-; Last update	:	26.3.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Equates used in Boot Menu.
 %ifndef BOOTMENU_INC
@@ -9,12 +5,12 @@
 
 ; Boot menu sizes
-MENU_TITLE_LINE_CNT		EQU	3		; Number of title lines
-MENU_INFO_LINE_CNT		EQU	3		; Number of info lines
-MENU_WIDTH_IN_CHARS		EQU	38		; Menu width in characters
-MENU_HEIGHT_IN_CHARS_WITH_INFO		EQU	(MENU_TITLE_LINE_CNT + MENU_INFO_LINE_CNT + 4)
-MENU_HEIGHT_IN_CHARS_WITHOUT_INFO	EQU	(MENU_TITLE_LINE_CNT + 3)
+BOOT_MENU_TITLE_LINES			EQU	2	; Number of title lines
+BOOT_MENU_INFO_LINES			EQU	3	; Number of info lines
+BOOT_MENU_TITLE_AND_INFO_LINES	EQU	(BOOT_MENU_TITLE_LINES | (BOOT_MENU_INFO_LINES<<8))
+BOOT_MENU_WIDTH					EQU	40	; Menu width in characters
+BOOT_MENU_HEIGHT_WITHOUT_ITEMS	EQU	(BOOT_MENU_TITLE_LINES + BOOT_MENU_INFO_LINES + 4)
 
 ; Function IDs
-ID_BOOTFUNC_ROMBOOT		EQU	0		; ROM boot
+ID_BOOTFUNC_ROMBOOT				EQU	0	; ROM boot
 
 
Index: /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	BootVars.inc
-; Project name	:	IDE BIOS
-; Created date	:	23.3.2010
-; Last update	:	9.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Defines for BOOTVARS struct used by boot menu
 ;					and drive initialization.
@@ -26,6 +22,5 @@
 	.dwSys18h		resb	4		;  800h, System INT 18h handler (Diskless boot, Boot failure)
 	.dwPostStack	resb	4		;  804h, POST stack when entering INT 19h
-	.bMenuHotkey	resb	1		;  808h, Boot Menu hotkey, zero if none pressed
-					resb	3
+					resb	4
 	.rgBootNfo		resb	73F4h	;  80Ch, Array containing BOOTNFO structs
 	.rgbMnuStack:					; 7C00h and below, Boot Menu stack
Index: /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RamVars.inc	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	RamVars.inc
-; Project name	:	IDE BIOS
-; Created date	:	23.3.2010
-; Last update	:	8.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	RAMVARS struct containing BIOS variables stored in RAM.
 %ifndef RAMVARS_INC
@@ -31,6 +27,5 @@
 
 	.wI13hDS:
-	.bEndTime		resb	1	; Timeout ending time
-					resb	1	; Alignment
+	.wTimeoutCounter	resb	2
 
 	.wDrvCntAndFirst:
Index: /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 88)
@@ -24,5 +24,5 @@
 	.bIdeCnt		resb	1	; Number of supported IDE controllers
 	.bBootDrv		resb	1	; Boot Menu default drive
-	.bBootMnuH		resb	1	; Boot Menu maximum height
+					resb	1	; (Was boot menu maximum height)
 	.bBootDelay		resb	1	; Boot Menu selection delay in seconds
 	.bBootLdrType	resb	1	; Boot Loader type
Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootInfo.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootInfo.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootInfo.asm	(revision 88)
@@ -1,8 +1,4 @@
 ; File name		:	BootInfo.asm
-; Project name	:	IDE BIOS
-; Created date	:	16.3.2010
-; Last update	:	6.1.2011
-; Author		:	Tomi Tilli,
-;				:	Krister Nordvall (optimizations)
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for generating and accessing drive
 ;					information to be displayed on boot menu.
@@ -145,5 +141,5 @@
 	loop	BootInfo_StoreAtaString	; Loop while words left
 .Return:
-	mov		al, STOP				; End string with STOP
+	xor		ax, ax					; Terminate string with NULL
 	stosb
 	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenu.asm	(revision 88)
@@ -1,8 +1,3 @@
-; File name		:	BootMenu.asm
-; Project name	:	IDE BIOS
-; Created date	:	25.3.2010
-; Last update	:	14.1.2011
-; Author		:	Tomi Tilli,
-;				:	Krister Nordvall (optimizations)
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Displays Boot Menu.
 
@@ -28,18 +23,27 @@
 	call	DriveXlate_Reset
 	call	BootMenuPrint_TheBottomOfScreen
-	call	BootMenu_GetMenuitemCount
-	mov		di, BootMenuEvent_Handler
 	call	BootMenu_Enter			; Get selected menuitem index to CX
 	call	BootMenuPrint_ClearScreen
-	test	cx, cx					; -1 if nothing selected (ESC pressed)
-	js		SHORT BootMenu_DisplayAndReturnSelection
-	call	BootMenu_CheckAndConvertHotkeyToMenuitem
-	jc		SHORT .SetDriveTranslationForHotkey
+	cmp		cx, BYTE NO_ITEM_SELECTED
+	je		SHORT BootMenu_DisplayAndReturnSelection
 	jmp		BootMenu_ConvertMenuitemToDriveOrFunction
-ALIGN JUMP_ALIGN
-.SetDriveTranslationForHotkey:
-	call	BootMenu_ConvertMenuitemToDriveOrFunction
-	call	DriveXlate_SetDriveToSwap
-	clc
+
+
+;--------------------------------------------------------------------
+; Enters Boot Menu or submenu.
+;
+; BootMenu_Enter
+;	Parameters:
+;		Nothing
+;	Returns:
+;		CX:		Index of selected item or NO_ITEM_SELECTED
+;	Corrupts registers:
+;		BX, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootMenu_Enter:
+	mov		bx, BootMenuEvent_Handler
+	CALL_MENU_LIBRARY DisplayWithHandlerInBXandUserDataInDXAX
+	xchg	cx, ax
 	ret
 
@@ -48,5 +52,5 @@
 ; Returns number of menuitems in Boot Menu.
 ;
-; BootMenu_GetMenuitemCount
+; BootMenu_GetMenuitemCountToCX
 ;	Parameters:
 ;		DS:		RAMVARS segment
@@ -57,5 +61,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenu_GetMenuitemCount:
+BootMenu_GetMenuitemCountToCX:
 	call	RamVars_GetHardDiskCountFromBDAtoCX
 	xchg	ax, cx
@@ -89,101 +93,19 @@
 
 ;--------------------------------------------------------------------
-; Enters Boot Menu or submenu.
-;
-; BootMenu_Enter
-;	Parameters:
-;		CX:		Number of menuitems in menu
-;		DS:SI:	User specific far pointer
-;		CS:DI:	Pointer to menu event handler function
-;	Returns:
-;		CX:		Index of last pointed Menuitem (not necessary selected with ENTER)
-;				FFFFh if cancelled with ESC
-;	Corrupts registers:
-;		AX, BX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenu_Enter:
-	call	BootMenu_GetSelectionTimeout
-	call	BootMenu_GetSize
-	MIN_U	ah, [cs:ROMVARS.bBootMnuH]		; Limit to max height
-	jmp		Menu_Enter
-
-;--------------------------------------------------------------------
-; Returns Boot Menu selection timeout in milliseconds.
-;
-; BootMenu_GetSelectionTimeout
-;	Parameters:
-;		Nothing
-;	Returns:
-;		DX:		Selection timeout in millisecs
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenu_GetSelectionTimeout:
-	mov		ax, 1000			; Seconds to milliseconds
-	eMOVZX	dx, BYTE [cs:ROMVARS.bBootDelay]
-	mul		dx					; AX = seconds * milliseconds_per_second
-	xchg	ax, dx				; DX = Timeout in millisecs
-	ret
-
-;--------------------------------------------------------------------
-; Returns Boot Menu size.
-;
-; BootMenu_GetSize
-;	Parameters:
-;		Nothing
-;	Returns:
-;		AL:		Menu width with borders included (characters)
-;		AH:		Menu height with borders included (characters)
-;		BL:		Title line count
-;		BH:		Info line count
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenu_GetSize:
-	mov		al, MENU_WIDTH_IN_CHARS
-	mov		ah, cl						; Copy menuitem count to AH
-	test	BYTE [cs:ROMVARS.wFlags], FLG_ROMVARS_DRVNFO
-	jz		SHORT .GetHeightWithoutInfoArea
-;.GetHeightWithInfoArea:
-	add		ah, MENU_HEIGHT_IN_CHARS_WITH_INFO
-	mov		bx, (MENU_INFO_LINE_CNT<<8) | MENU_TITLE_LINE_CNT
-	ret
-ALIGN JUMP_ALIGN
-.GetHeightWithoutInfoArea:
-	add		ah, MENU_HEIGHT_IN_CHARS_WITHOUT_INFO
-	mov		bx, MENU_TITLE_LINE_CNT
-	ret
-
-
-;--------------------------------------------------------------------
-; Checks if hotkey has been pressed on Boot Menu.
-; If it has been, it will be converted to menuitem index.
-;
-; BootMenu_CheckAndConvertHotkeyToMenuitem
-;	Parameters:
-;		CX:		Menuitem index (if no hotkey)
-;	Returns:
-;		CX:		Menuitem index
-;		CF:		Set if hotkey has been pressed
-;				Cleared if no hotkey selection
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenu_CheckAndConvertHotkeyToMenuitem:
-	push	es
-	LOAD_BDA_SEGMENT_TO	es, ax				; Zero AX
-	xchg	al, [es:BOOTVARS.bMenuHotkey]	; Load and clear hotkey
-	test	al, al							; No hotkey? (clears CF)
-	jz		SHORT .Return
-	call	BootMenu_ConvertHotkeyToMenuitem
-	stc
-ALIGN JUMP_ALIGN
-.Return:
-	pop		es
-	ret
+; BootMenu_GetHeightToALwithItemCountInCL
+;	Parameters:
+;		CL:		Number of menuitems
+;	Returns:
+;		AH:		Boot menu height
+;	Corrupts registers:
+;		AL, CL, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootMenu_GetHeightToAHwithItemCountInCL:
+	add		cl, BOOT_MENU_HEIGHT_WITHOUT_ITEMS
+	CALL_DISPLAY_LIBRARY GetColumnsToALandRowsToAH
+	MIN_U	ah, cl
+	ret
+
 
 ;--------------------------------------------------------------------
Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuEvent.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	BootMenuEvent.asm
-; Project name	:	IDE BIOS
-; Created date	:	26.3.2010
-; Last update	:	1.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Boot Menu event handler for menu library callbacks.
 
@@ -9,276 +5,67 @@
 SECTION .text
 
+struc ITEM_TYPE_REFRESH
+	.HardDisk			resb	2
+	.FloppyDrive		resb	2
+	.SpecialFunction	resb	2
+endstruc
+
+
 ;--------------------------------------------------------------------
-; Boot Menu event handler.
-;
 ; BootMenuEvent_Handler
-;	Parameters:
-;		BX:		Callback event
-;		CX:		Menuitem index (usually index of selected Menuitem)
-;		DX:		Event parameter (event specific)
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AH:		Event specific or unused. Set to 0 if unused.
-;		AL:		1=Event processed
-;				0=Event not processed (default action if any)
+;	Common parameters for all events:
+;		BX:			Menu event (anything from MENUEVENT struct)
+;		SS:BP:		Menu library handle
+;	Common return values for all events:
+;		CF:			Set if event processed
+;					Cleared if event not processed
 ;	Corrupts registers:
-;		BX, CX, DX
+;		All
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootMenuEvent_Handler:
-	push	es
-	push	ds
-	push	di
-	push	si
+	cmp		bx, MENUEVENT.RefreshItemFromCX	; Above last supported item?
+	ja		SHORT .EventNotHandled
+	jmp		[bx+.rgfnEventSpecificHandlers]
+.EventNotHandled:
+.IdleProcessing:
+	clc
+	ret
 
-	xor		ax, ax									; Event not processed
-	cmp		bx, BYTE EVNT_MNU_GETDEF				; Event in jump table?
-	ja		SHORT .Return
-	shl		bx, 1
-	call	[cs:bx+.rgwEventJmp]
-.Return:
-	pop		si
-	pop		di
-	pop		ds
-	pop		es
-	ret
 ALIGN WORD_ALIGN
-.rgwEventJmp:
-	dw		BootMenuEvent_Exit						; 0, EVNT_MNU_EXIT (Menu will quit)
-	dw		BootMenuEvent_EventItemSelectionChanged	; 1, EVNT_MMU_SELCHG (Menuitem selection changed (with arrows))
-	dw		BootMenuEvent_EventItemSelected			; 2, EVNT_MNU_SELSET (Menuitem selected (with Enter))
-	dw		BootMenuEvent_EventKeyPressed			; 3, EVNT_MNU_KEY (Keyboard key pressed)
-	dw		BootMenuEvent_EventMenuDraw				; 4, EVNT_MNU_UPD (Menu needs to be updated)
-	dw		BootMenuEvent_EventGetDefaultMenuitem	; 5, EVNT_MNU_GETDEF (Request menuitem to be selected by default)
+.rgfnEventSpecificHandlers:
+	dw		.InitializeMenuinitFromDSSI
+	dw		.EventCompleted
+	dw		.IdleProcessing
+	dw		.ItemHighlightedFromCX
+	dw		.ItemSelectedFromCX
+	dw		.KeyStrokeInAX
+	dw		BootMenuPrint_TitleStrings
+	dw		.RefreshInformation
+	dw		.RefreshItemFromCX
 
 
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Menu Exit notification (EVNT_MNU_EXIT).
-;
-; BootMenuEvent_Exit
-;	Parameters:
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AH:		1 to cancel exit
-;				0 to allow menu exit
-;		AL:		1 = Event processed
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
+; Parameters:
+;	DS:SI:		Ptr to MENUINIT struct to initialize
+; Returns:
+;	DS:SI:		Ptr to initialized MENUINIT struct
 ALIGN JUMP_ALIGN
-BootMenuEvent_Exit:
-	mov		ax, 1					; Event handled
+.InitializeMenuinitFromDSSI:
+	push	ds
+	call	RamVars_GetSegmentToDS
+	call	.GetDefaultMenuitemToDX
+	call	BootMenu_GetMenuitemCountToCX
+	pop		ds
+	mov		[si+MENUINIT.wItems], cx
+	mov		[si+MENUINIT.wHighlightedItem], dx
+	mov		WORD [si+MENUINIT.wTitleAndInfoLines], BOOT_MENU_TITLE_AND_INFO_LINES
+	mov		BYTE [si+MENUINIT.bWidth], BOOT_MENU_WIDTH
+	call	BootMenu_GetHeightToAHwithItemCountInCL
+	mov		[si+MENUINIT.bHeight], ah
+	stc
 	ret
 
-
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Menuitem Selection Changed notification (EVNT_MMU_SELCHG).
-;
-; BootMenuEvent_EventItemSelectionChanged
-;	Parameters:
-;		CX:		Index of selected Menuitem
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		1 = Event processed
-;	Corrupts registers:
-;		BX, CX, DX, DI
-;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenuEvent_EventItemSelectionChanged:
-	call	RamVars_GetSegmentToDS
-	call	DriveXlate_Reset
-	call	BootMenu_ConvertMenuitemToDriveOrFunction
-	jc		SHORT BootMenuEvent_UpdateAllMenuitems	; Selection changed to a function
-	call	DriveXlate_SetDriveToSwap
-	; Fall to BootMenuEvent_UpdateAllMenuitems
-
-;--------------------------------------------------------------------
-; Redraws all menuitems.
-;
-; BootMenuEvent_UpdateAllMenuitems
-;	Parameters:
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		1 = Event processed
-;	Corrupts registers:
-;		BX, CX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_UpdateAllMenuitems:
-	mov		cx, -1					; Update all items
-	mov		dl, MFL_UPD_ITEM | MFL_UPD_NFO | MFL_UPD_NOCLEAR
-	call	Menu_Invalidate
-	mov		ax, 1					; Event handled
-	ret
-
-
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Menuitem Selected notification (EVNT_MNU_SELSET).
-;
-; BootMenuEvent_EventItemSelected
-;	Parameters:
-;		CX:		Index of selected Menuitem
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		1 = Event processed
-;	Corrupts registers:
-;		BX, CX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_EventItemSelected:
-	call	Menu_Exit				; Exit from menu
-	mov		ax, 1					; Event handled
-	ret
-
-
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Key pressed notification (EVNT_MNU_KEY).
-;
-; BootMenuEvent_EventKeyPressed
-;	Parameters:
-;		CX:		Index of currently selected Menuitem
-;		DL:		ASCII character
-;		DH:		BIOS Scan Code
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		1 = Event processed
-;	Corrupts registers:
-;		BX, CX, DX, DS
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_EventKeyPressed:
-	mov		al, dl					; Copy ASCII char to AL
-	sub		al, 'a'-'A'				; To upper case character
-	cmp		al, 'A'					; First possible drive letter?
-	jb		SHORT .Return			;  If below, return
-	cmp		al, 'Z'					; Last possible drive letter?
-	ja		SHORT .Return			;  If above, return
-	LOAD_BDA_SEGMENT_TO	ds, dx
-	mov		[BOOTVARS.bMenuHotkey], al
-	jmp		SHORT BootMenuEvent_EventItemSelected
-.Return:
-	mov		ax, 1
-	ret
-
-
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Menu Update notification (EVNT_MNU_UPD).
-;
-; BootMenuEvent_EventMenuDraw
-;	Parameters:
-;		CX: 	Index of Menuitem to update (if MFL_UPD_ITEM set)
-;		DL:		Update flag (only one):
-;					MFL_UPD_TITLE	Update Menu Title string(s)
-;					MFL_UPD_NFO		Update Menu Info string(s)
-;					MFL_UPD_ITEM	Update Menuitem string
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		Was event processed
-;	Corrupts registers:
-;		BX, CX, DX, SI, DI, DS
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_EventMenuDraw:
-	test	dl, MFL_UPD_ITEM		; Need to update Menuitem?
-	jnz		SHORT BootMenuEvent_DrawMenuitem
-	test	dl, MFL_UPD_NFO			; Need to update Info String(s)?
-	jnz		SHORT BootMenuEvent_DrawInfo
-	test	dl, MFL_UPD_TITLE		; Need to update Title String(s)?
-	jnz		SHORT BootMenuEvent_DrawTitle
-	xor		ax, ax
-	ret
-
-;--------------------------------------------------------------------
-; Draws Menuitem string. Cursor is set to a menuitem location.
-;
-; BootMenuEvent_DrawMenuitem
-;	Parameters:
-;		CX: 	Index of Menuitem to draw
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		Was event processed
-;	Corrupts registers:
-;		BX, CX, DX, SI, DI, DS, ES
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_DrawMenuitem:
-	call	RamVars_GetSegmentToDS
-	call	BootMenu_ConvertMenuitemToDriveOrFunction
-	jc		SHORT .DrawFunctionItem
-	call	BootMenuPrint_TranslatedDriveNumber
-	test	dl, 80h					; Floppy drive?
-	jz		SHORT .DrawFloppyDriveItem
-	jmp		BootMenuPrint_HardDiskMenuitem
-ALIGN JUMP_ALIGN
-.DrawFunctionItem:
-	jmp		BootMenuPrint_FunctionMenuitem
-ALIGN JUMP_ALIGN
-.DrawFloppyDriveItem:
-	jmp		BootMenuPrint_FloppyMenuitem
-
-;--------------------------------------------------------------------
-; Draws information strings. Cursor is set to a first information line.
-;
-; BootMenuEvent_DrawInfo
-;	Parameters:
-;		CX: 	Index of selected menuitem
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		Was event processed
-;	Corrupts registers:
-;		BX, CX, DX, SI, DI, DS, ES
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_DrawInfo:
-	call	RamVars_GetSegmentToDS
-	call	BootMenu_ConvertMenuitemToDriveOrFunction
-	jc		SHORT .DrawFunctionInfo
-	test	dl, 80h					; Floppy drive?
-	jz		SHORT .DrawFloppyDriveInfo
-	jmp		BootMenuPrint_HardDiskMenuitemInformation
-ALIGN JUMP_ALIGN
-.DrawFunctionInfo:
-	jmp		BootMenuPrint_FunctionMenuitemInformation
-ALIGN JUMP_ALIGN
-.DrawFloppyDriveInfo:
-	jmp		BootMenuPrint_FloppyMenuitemInformation
-
-;--------------------------------------------------------------------
-; Draws title strings. Cursor is set to a first title line.
-;
-; BootMenuEvent_DrawTitle
-;	Parameters:
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		Was event processed
-;	Corrupts registers:
-;		CX, DX, SI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_DrawTitle:
-	jmp		BootMenuPrint_TitleStrings
-
-
-;--------------------------------------------------------------------
-; Boot Menu event handler.
-; Handles Get Default Menuitem notification (EVNT_MNU_GETDEF).
-;
-; BootMenuEvent_EventGetDefaultMenuitem
-;	Parameters:
-;		SS:BP:	Ptr to MENUVARS
-;	Returns:
-;		AX:		Was event processed
-;		CX:		Index of menuitem to set selected
-;	Corrupts registers:
-;		BX, CX, DX, DI, DS
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuEvent_EventGetDefaultMenuitem:
-	call	RamVars_GetSegmentToDS
+.GetDefaultMenuitemToDX:
 	mov		dl, [cs:ROMVARS.bBootDrv]	; Default boot drive
 	call	BootMenu_IsDriveInSystem
@@ -286,8 +73,114 @@
 	call	DriveXlate_SetDriveToSwap
 	call	BootMenu_ConvertDriveToMenuitem
-	mov		ax, 1
+	mov		dx, cx
 	ret
 ALIGN JUMP_ALIGN
 .DoNotSetDefaultMenuitem:
-	xor		ax, ax
+	xor		dx, dx						; Whatever appears first on boot menu
 	ret
+
+
+; Parameters:
+;	CX:			Index of new highlighted item
+;	DX:			Index of previously highlighted item or NO_ITEM_HIGHLIGHTED
+ALIGN JUMP_ALIGN
+.ItemHighlightedFromCX:
+	push	cx
+	push	dx
+	call	RamVars_GetSegmentToDS
+	call	DriveXlate_Reset
+	call	BootMenu_ConvertMenuitemToDriveOrFunction
+	jc		SHORT .UpdatePreviousAndNewMenuitem	; Selection changed to a function
+	call	DriveXlate_SetDriveToSwap
+
+.UpdatePreviousAndNewMenuitem:
+	pop		ax		; Update previous item
+	CALL_MENU_LIBRARY RefreshItemFromAX
+	pop		ax		; Update new item
+	CALL_MENU_LIBRARY RefreshItemFromAX
+	CALL_MENU_LIBRARY RefreshInformation
+	stc
+	ret
+
+
+; Parameters:
+;	AL:			ASCII character for the key
+;	AH:			Keyboard library scan code for the key
+ALIGN JUMP_ALIGN
+.KeyStrokeInAX:
+	xor		ah, ah					; ASCII drive letter now in AX
+	call	BootMenu_ConvertHotkeyToMenuitem
+	cmp		cx, [bp+MENUINIT.wItems]
+	jae		SHORT .EventNotHandled	; Invalid key
+	xchg	ax, cx
+	CALL_MENU_LIBRARY HighlightItemFromAX
+	; Fall to .ItemSelectedFromCX
+
+
+; Parameters:
+;	CX:			Index of selected item
+ALIGN JUMP_ALIGN
+.ItemSelectedFromCX:
+	CALL_MENU_LIBRARY Close
+.EventCompleted:
+	stc
+	ret
+
+
+; Parameters:
+;	CX:			Index of item to refresh
+;	Cursor has been positioned to the beginning of item line
+ALIGN JUMP_ALIGN
+.RefreshItemFromCX:
+	mov		bx, .rgwItemTypeRefresh
+	jmp		SHORT .RefreshItemOrInformationWithJumpTableInCSBX
+
+
+; Parameters:
+;	CX:			Index of highlighted item
+;	Cursor has been positioned to the beginning of first line
+ALIGN JUMP_ALIGN
+.RefreshInformation:
+	mov		bx, .rgwInformationItemTypeRefresh
+	; Fall to .RefreshItemOrInformationWithJumpTableInCSBX
+
+;--------------------------------------------------------------------
+; RefreshItemOrInformationWithJumpTableInCSBX
+;	Parameters:
+;		CX: 	Index of selected menuitem
+;		CS:BX:	Ptr to ITEM_TYPE_REFRESH jump table
+;	Returns:
+;		CF:		set since event processed
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+.RefreshItemOrInformationWithJumpTableInCSBX:
+	cmp		cl, NO_ITEM_HIGHLIGHTED
+	je		SHORT .EventCompleted
+
+	call	RamVars_GetSegmentToDS
+	call	BootMenu_ConvertMenuitemToDriveOrFunction
+	jc		SHORT .DrawFunction
+	test	dl, 80h					; Floppy drive?
+	jz		SHORT .DrawFloppyDrive
+	jmp		[cs:bx+ITEM_TYPE_REFRESH.HardDisk]
+ALIGN JUMP_ALIGN
+.DrawFunction:
+	jmp		[cs:bx+ITEM_TYPE_REFRESH.SpecialFunction]
+ALIGN JUMP_ALIGN
+.DrawFloppyDrive:
+	jmp		[cs:bx+ITEM_TYPE_REFRESH.FloppyDrive]
+
+; Jump tables for .RefreshItemOrInformationWithJumpTableInCSBX
+ALIGN WORD_ALIGN
+.rgwItemTypeRefresh:
+istruc ITEM_TYPE_REFRESH
+	at	ITEM_TYPE_REFRESH.HardDisk,			dw	BootMenuPrint_HardDiskMenuitem
+	at	ITEM_TYPE_REFRESH.FloppyDrive,		dw	BootMenuPrint_FloppyMenuitem
+	at	ITEM_TYPE_REFRESH.SpecialFunction, 	dw	BootMenuPrint_FunctionMenuitem
+iend
+.rgwInformationItemTypeRefresh:
+istruc ITEM_TYPE_REFRESH
+	at	ITEM_TYPE_REFRESH.HardDisk,			dw	BootMenuPrint_HardDiskMenuitemInformation
+	at	ITEM_TYPE_REFRESH.FloppyDrive,		dw	BootMenuPrint_FloppyMenuitemInformation
+	at	ITEM_TYPE_REFRESH.SpecialFunction, 	dw	BootMenuPrint_ClearInformationArea
+iend
